# demo package, to test if everything works
from pipelines.interfaces import IFilter, AbortPipelineException
from zope.interface import Interface, implements

from xml.dom.minidom import parseString
from xml.dom.minidom import Element, Text
from xml.parsers.expat import ExpatError

class domify(object):
    implements(IFilter)

    def __call__(self, data, state):
        try:
            state.dom = parseString(data.request.response._body)
        except ExpatError:
            raise AbortPipelineException, "Error during xml parsing" 

class addcopy(object):
    implements(IFilter)

    def __call__(self, data, state):
        dom = state.dom
        graph = Element(tagName='p')
        text = Text()
        text.data = 'Copyright 2005 Example Company'
        graph.appendChild(text)
        bodytags = dom.getElementsByTagName('body')
        if len(bodytags) > 0: # is there a body? (avoid IndexError)
            body = bodytags[0]
            body.appendChild(graph)
        # else we might as well abort? Or stop gracefully?

class addlocalremark(object):
    implements(IFilter)

    def __call__(self, data, state):
        dom = state.dom
        graph = Element(tagName='p')
        text = Text()
        text.data = "You're in a subsite"
        graph.appendChild(text)
        bodytags = dom.getElementsByTagName('body')
        if len(bodytags) > 0: # is there a body? (avoid IndexError)
            body = bodytags[0]
            body.appendChild(graph)
        # else we might as well abort? Or stop gracefully?

class stringify(object):
    implements(IFilter)

    def __call__(self, data, state):
        response = data.request.response
        dom = state.dom
        response.setBody(dom.toxml())
